// AutoRichEditCtrl.cpp : implementation file
//

#include "stdafx.h" 
#include "AutoRichEditCtrl.h"
#include "MStringDlg.h"
#include "AcToRtf.h"
#include "Util_MString.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAutoRichEditCtrl

CAutoRichEditCtrl::CAutoRichEditCtrl()
{
}

CAutoRichEditCtrl::~CAutoRichEditCtrl()
{
}


BEGIN_MESSAGE_MAP(CAutoRichEditCtrl, CRichEditCtrl)
	//{{AFX_MSG_MAP(CTWScriptEdit)
	ON_CONTROL_REFLECT(EN_CHANGE, OnChange)
	ON_WM_RBUTTONDOWN()
	//ON_WM_CREATE()
	//ON_WM_CHAR()
	//ON_WM_KILLFOCUS()
	//ON_CONTROL_REFLECT(EN_CHANGE, OnChange)
	//ON_WM_LBUTTONDBLCLK()
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_COMMAND(ID_EDIT_SELECTALL, OnEditSelectAll)
	//}}AFX_MSG_MAP
	ON_NOTIFY_REFLECT(EN_SELCHANGE, OnSelChange)
	
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAutoRichEditCtrl message handlers

CString CAutoRichEditCtrl::GetRTF()
{
	// Return the RTF string of the text in the control.
	
	// Stream out here.
	EDITSTREAM es;
	es.dwError = 0;
	es.pfnCallback = CBStreamOut;		// Set the callback

	CString sRTF = "";

	es.dwCookie = (DWORD) &sRTF;	// so sRTF receives the string
	
	StreamOut(SF_RTF, es);			// Call CRichEditCtrl::StreamOut to get the string.
	///

	return sRTF;

}

void CAutoRichEditCtrl::SetRTF(CString sRTF)
{
	// Put the RTF string sRTF into the rich edit control.

	// Read the text in
	EDITSTREAM es;
	es.dwError = 0;
	es.pfnCallback = CBStreamIn;
	es.dwCookie = (DWORD) &sRTF;
	StreamIn(SF_RTF, es);	// Do it.
	
}

/*
	Callback function to stream an RTF string into the rich edit control.
*/
DWORD CALLBACK CAutoRichEditCtrl::CBStreamIn(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
{
	// We insert the rich text here.

/*	
	This function taken from CodeGuru.com
	http://www.codeguru.com/richedit/rtf_string_streamin.shtml
	Zafir Anjum
*/

	CString *pstr = (CString *) dwCookie;

	if (pstr->GetLength() < cb)
	{
		*pcb = pstr->GetLength();
		memcpy(pbBuff, (LPCSTR) *pstr, *pcb);
		pstr->Empty();
	}
	else
	{
		*pcb = cb;
		memcpy(pbBuff, (LPCSTR) *pstr, *pcb);
		*pstr = pstr->Right(pstr->GetLength() - cb);
	}
	///

	return 0;
}

/*
	Callback function to stream the RTF string out of the rich edit control.
*/
DWORD CALLBACK CAutoRichEditCtrl::CBStreamOut(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
{
	// Address of our string var is in psEntry
	CString *psEntry = (CString*) dwCookie;
	

	CString tmpEntry = "";
	tmpEntry = (CString) pbBuff;

	// And write it!!!
	*psEntry += tmpEntry.Left(cb);

	return 0;
}

bool CAutoRichEditCtrl::SelectionIsBold()
{
	CHARFORMAT cf = GetCharFormat();	
	
	if (cf.dwEffects & CFM_BOLD)
		return true;
	else
		return false;
}

bool CAutoRichEditCtrl::SelectionIsItalic()
{
	CHARFORMAT cf = GetCharFormat();	
	
	if (cf.dwEffects & CFM_ITALIC)
		return true;
	else
		return false;
}

bool CAutoRichEditCtrl::SelectionIsUnderlined()
{
	CHARFORMAT cf = GetCharFormat();	
	
	if (cf.dwEffects & CFM_UNDERLINE)
		return true;
	else
		return false;
}

CHARFORMAT CAutoRichEditCtrl::GetCharFormat(DWORD dwMask)
{
	CHARFORMAT cf;
	cf.cbSize = sizeof(CHARFORMAT);

	cf.dwMask = dwMask;

	GetSelectionCharFormat(cf);

	return cf;
}

void CAutoRichEditCtrl::SetCharStyle(int MASK, int STYLE, int nStart, int nEnd)
{
	CHARFORMAT cf;
	cf.cbSize = sizeof(CHARFORMAT);
	//cf.dwMask = MASK;
	
	GetSelectionCharFormat(cf);
	
	if (cf.dwMask & MASK)	// selection is all the same
	{
		cf.dwEffects ^= STYLE; 
	}
	else
	{
		cf.dwEffects |= STYLE;
	}
	
	cf.dwMask = MASK;

	SetSelectionCharFormat(cf);

}

void CAutoRichEditCtrl::SetSelectionBold()
{
	long start=0, end=0;
	GetSel(start, end);		// Get the current selection

	SetCharStyle(CFM_BOLD, CFE_BOLD, start, end);	// Make it bold
}

void CAutoRichEditCtrl::SetSelectionItalic()
{
	long start=0, end=0;
	GetSel(start, end);

	SetCharStyle(CFM_ITALIC, CFE_ITALIC, start, end);
}

void CAutoRichEditCtrl::SetSelectionUnderlined()
{
	long start=0, end=0;
	GetSel(start, end);

	SetCharStyle(CFM_UNDERLINE, CFE_UNDERLINE, start, end);
}

void CAutoRichEditCtrl::SetParagraphCenter()
{
	
	PARAFORMAT paraFormat;    
	paraFormat.cbSize = sizeof(PARAFORMAT);
	paraFormat.dwMask = PFM_ALIGNMENT;    
	paraFormat.wAlignment = PFA_CENTER;
	SetParaFormat(paraFormat);	// Set the paragraph.
}

void CAutoRichEditCtrl::SetParagraphLeft()
{
	PARAFORMAT paraFormat;
	paraFormat.cbSize = sizeof(PARAFORMAT);
	paraFormat.dwMask = PFM_ALIGNMENT;    
	paraFormat.wAlignment = PFA_LEFT;
	
	SetParaFormat(paraFormat);
}

void CAutoRichEditCtrl::SetParagraphRight()
{
	PARAFORMAT paraFormat;
	paraFormat.cbSize = sizeof(PARAFORMAT);
	paraFormat.dwMask = PFM_ALIGNMENT;    
	paraFormat.wAlignment = PFA_RIGHT;
	
	SetParaFormat(paraFormat);
}

bool CAutoRichEditCtrl::ParagraphIsCentered()
{
	PARAFORMAT pf = GetParagraphFormat();

	if (pf.wAlignment == PFA_CENTER)
		return true;
	else
		return false;
}

bool CAutoRichEditCtrl::ParagraphIsLeft()
{
	PARAFORMAT pf = GetParagraphFormat();

	if (pf.wAlignment == PFA_LEFT)
		return true;
	else
		return false;
}

bool CAutoRichEditCtrl::ParagraphIsRight()
{
	PARAFORMAT pf = GetParagraphFormat();

	if (pf.wAlignment == PFA_RIGHT)
		return true;
	else
		return false;
}

PARAFORMAT CAutoRichEditCtrl::GetParagraphFormat()
{
	PARAFORMAT pf;
	pf.cbSize = sizeof(PARAFORMAT);

	pf.dwMask = PFM_ALIGNMENT | PFM_NUMBERING;    	

	GetParaFormat(pf);

	return pf;
}

void CAutoRichEditCtrl::SetParagraphBulleted()
{
	PARAFORMAT paraformat = GetParagraphFormat();

	if ( (paraformat.dwMask & PFM_NUMBERING) && (paraformat.wNumbering == PFN_BULLET) )
	{
		paraformat.wNumbering = 0;
		paraformat.dxOffset = 0;
		paraformat.dxStartIndent = 0;
		paraformat.dwMask = PFM_NUMBERING | PFM_STARTINDENT | PFM_OFFSET;
	}
	else
	{
		paraformat.wNumbering = PFN_BULLET;
		paraformat.dwMask = PFM_NUMBERING;
		if (paraformat.dxOffset == 0)
		{
			paraformat.dxOffset = 4;
			paraformat.dwMask = PFM_NUMBERING | PFM_STARTINDENT | PFM_OFFSET;
		}
	}
	
	SetParaFormat(paraformat);

}

bool CAutoRichEditCtrl::ParagraphIsBulleted()
{
	PARAFORMAT pf = GetParagraphFormat();

	if (pf.wNumbering == PFN_BULLET)
		return true;
	else
		return false;
}

void CAutoRichEditCtrl::SelectColor()
{
	CColorDialog dlg;

	CHARFORMAT cf = GetCharFormat();

	if (cf.dwEffects & CFE_AUTOCOLOR) cf.dwEffects -= CFE_AUTOCOLOR;

	// Get a color from the common color dialog.
	if( dlg.DoModal() == IDOK )
	{	
		cf.crTextColor = dlg.GetColor();
	}

	cf.dwMask = CFM_COLOR;

	SetSelectionCharFormat(cf);
}

void CAutoRichEditCtrl::SetFontName(CString sFontName)
{
	CHARFORMAT cf = GetCharFormat();
	strcpy(cf.szFaceName, sFontName); 

	cf.dwMask = CFM_FACE;

	SetSelectionCharFormat(cf);
}

void CAutoRichEditCtrl::SetFontSize(double nPointSize,bool defaultSize)
{
	CHARFORMAT cf = GetCharFormat();

	nPointSize *= 20;	// convert from to twips
	cf.yHeight = (int)nPointSize;
	
	cf.dwMask = CFM_SIZE;
	if (defaultSize==FALSE)
		SetSelectionCharFormat(cf);
	else
		SetDefaultCharFormat(cf);
}

void CAutoRichEditCtrl::GetSystemFonts(CStringArray &saFontList)
{
	CDC *pDC = GetDC ();
	//EnumFonts (pDC->GetSafeHdc(),NULL,(FONTENUMPROC) CBEnumFonts,(LPARAM)&saFontList);//Enumerate
    LOGFONT lf;
	//memset(&lf, 0, sizeof(LOGFONT));
	lf.lfCharSet = DEFAULT_CHARSET;
    strcpy(lf.lfFaceName, "");
	EnumFontFamiliesEx (pDC->GetSafeHdc(),&lf,(FONTENUMPROC) CBEnumFonts,(LPARAM)&saFontList,0);//Enumerate
}

BOOL CALLBACK CAutoRichEditCtrl::CBEnumFonts(LPLOGFONT lplf, LPTEXTMETRIC lptm, DWORD dwType, LPARAM lpData)
{
	// This function was written with the help of CCustComboBox, by Girish Bharadwaj.
	// Available from Codeguru.

	if ((dwType == TRUETYPE_FONTTYPE) && (lplf->lfCharSet == RUSSIAN_CHARSET))
		((CStringArray *) lpData)->Add( lplf->lfFaceName);

	return true;
}

CString CAutoRichEditCtrl::GetSelectionFontName()
{
	CHARFORMAT cf = GetCharFormat();

	CString sName = cf.szFaceName;

	return sName;
}

double CAutoRichEditCtrl::GetSelectionFontSize()
{
	CHARFORMAT cf = GetCharFormat();

	double nSize = (double)cf.yHeight/20;

	return nSize;
}
void CAutoRichEditCtrl::OnChange()
{


      int nChildID = GetDlgCtrlID();
      WPARAM wParam = MAKEWPARAM((WORD)nChildID, ENM_CHANGE);

      GetParent()->SendMessage(WM_COMMAND, wParam, (LPARAM)m_hWnd);
	  
}
void CAutoRichEditCtrl::OnSelChange(NMHDR* pNMHDR, LRESULT* pResult)
{
	//SELCHANGE *pSelChange = reinterpret_cast<SELCHANGE *>(pNMHDR);
	// TODO: The control will not send this notification unless you override the
	// CDialog::OnInitDialog() function to send the EM_SETEVENTMASK message
	// to the control with the ENM_SELCHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	SELCHANGE* pSC = (SELCHANGE*)pNMHDR;
	  
	
	int nChildID = GetDlgCtrlID();
      WPARAM wParam = MAKEWPARAM((WORD)nChildID, ENM_SELCHANGE);

      GetParent()->SendMessage(WM_COMMAND, wParam, (LPARAM)m_hWnd);


	*pResult = 0;

}



COLORREF CAutoRichEditCtrl::getSelectionColor()
{
	CHARFORMAT cf = GetCharFormat();
	COLORREF clr=cf.crTextColor;

	return clr;
}

BYTE CAutoRichEditCtrl::GetSelectionFontCharset()
{
	CHARFORMAT cf = GetCharFormat();

	BYTE bChSet = cf.bCharSet;

	return bChSet;
}






void CAutoRichEditCtrl::OnRButtonDown(UINT nFlags, CPoint point) 
{

	long nStartChar,nEndChar,nDelta;
	CString sLen;
	
	GetSel(nStartChar,nEndChar);
	nDelta=nEndChar-nStartChar;
	GetWindowText(sLen);
	
	CMenu cMenu;
	cMenu.CreatePopupMenu();
	cMenu.AppendMenu(MF_STRING, ID_EDIT_UNDO, "");
	

	if (nDelta!=0)
	{
		cMenu.AppendMenu(MF_SEPARATOR);
		cMenu.AppendMenu(MF_STRING, ID_EDIT_CUT, "");
		cMenu.AppendMenu(MF_STRING, ID_EDIT_COPY, "");
	}
	if (IsClipboard()!=0)
	{
		cMenu.AppendMenu(MF_SEPARATOR);
		cMenu.AppendMenu(MF_STRING, ID_EDIT_PASTE, "");
		
	}
	if (sLen.GetLength()!=0)
	{
		cMenu.AppendMenu(MF_SEPARATOR);
		cMenu.AppendMenu(MF_STRING, ID_EDIT_SELECTALL, " ");
	}
	

	CPoint pt(GetMessagePos());

	cMenu.TrackPopupMenu(TPM_LEFTALIGN|TPM_RIGHTBUTTON, pt.x, pt.y, this);

	cMenu.DestroyMenu();

}


void CAutoRichEditCtrl::OnEditCopy() 
{
	Copy();	
}



void CAutoRichEditCtrl::OnEditCut() 
{
	Cut();	
}


void CAutoRichEditCtrl::OnEditPaste() 
{
int k=IsClipboard();
  if (k!=0)
  {
	RestoreWaitCursor();
	BeginWaitCursor();

	long nStartChar, nEndChar;
	GetSel(nStartChar,nEndChar);
	mglstring.pst=TRUE;
	Paste();	
	SetSel(nStartChar,nStartChar+k);
	SetSel(nStartChar+k,nStartChar+k);
	mglstring.pst=FALSE;
	EndWaitCursor();

	SetFocus();
  }

}



void CAutoRichEditCtrl::OnEditUndo() 
{
	Undo();
}



void CAutoRichEditCtrl::OnEditSelectAll()
{
	SetSel(0,-1);
}

int CAutoRichEditCtrl::IsClipboard()
{
	CString s;
	int k;
	char * buffer;
	if(OpenClipboard())
	{
		
		if (IsClipboardFormatAvailable(CF_TEXT)==0)
		{
			CloseClipboard(); 
			return 0;
		}
		HANDLE hData = GetClipboardData( CF_TEXT );
		buffer = (char*)GlobalLock( hData );
		s=(CString)buffer;
		k=s.GetLength();
		
	}

	CloseClipboard(); 

	if (k==0)
		return 0;
	else if (k>16384)
	{
		MessageBox("   ,   16","-M",MB_ICONWARNING	);
		return 0;
	}
	else
		return k;
}
