// MStringDlg.cpp : implementation file
//  

#include "stdafx.h"
#include "stdafx.h"
#include "MStringDlg.h"
#include <AVBAcad.h>
#include "InfoDlg.h"
#include "Util_MString.h"
#include <AVBTextUtil.h>
#include "MString.h"
#include "AcToRtf.h"
#include <rxmfcapi.h>
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
AcDbObjectId styleId;
/////////////////////////////////////////////////////////////////////////////
// MStringDlg dialog


MStringDlg::MStringDlg(CWnd* pParent /*=NULL*/)
	: CAcUiDialog(MStringDlg::IDD, pParent)
{

	//{{AFX_DATA_INIT(MStringDlg)
	m_scombo_style = _T("");
	m_scombo_height = _T("");
	m_scombo_rotation = _T("");
	m_scombo_angle = _T("");
	m_sEdit = _T("");
	m_vcheck_bold = FALSE;
	m_vcheck_italic = FALSE;
	m_vcheck_under = FALSE;
	m_srichedit = _T("");
	m_vcheck_course = FALSE;
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON_AVB);
	m_pToolTip = NULL;
	m_vcheck_look = FALSE;
	m_minWidth = m_minHeight = 0;
	m_old_cx = m_old_cy = 0;
	m_bSizeChanged = FALSE;
	m_nIDTemplate = IDD_DIALOG_MTEXT;

	m_bRememberSize = TRUE;
	m_bDrawGripper = TRUE;

	//}}AFX_DATA_INIT
	SetControlInfo(IDC_RICHEDIT,RESIZE_HOR | RESIZE_VER);
	SetControlInfo(IDC_STATIC_CAPS,ANCHORE_BOTTOM | ANCHORE_RIGHT );
	SetControlInfo(IDC_STATIC_NUM,ANCHORE_BOTTOM | ANCHORE_RIGHT);
	SetControlInfo(IDC_STATIC_RE,ANCHORE_BOTTOM | ANCHORE_RIGHT);

}

void MStringDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(MStringDlg)
	DDX_Control(pDX, IDC_BUTTON_LOOK, m_cbutton_look);
	DDX_Control(pDX, IDC_EDIT_WIDTH, m_vedit_width);
	DDX_Control(pDX, IDC_BUTTON_COURSE, m_cbutton_course);
	DDX_Control(pDX, IDC_BUTTON_Y, m_cbutton_minus);
	DDX_Control(pDX, IDC_BUTTON_X, m_cbutton_plus);
	DDX_Control(pDX, IDC_COMBO_SPACE_STYLE, m_ccombo_space_style);
	DDX_Control(pDX, IDC_BUTTON_SPACE_P, m_cbutton_space_p);
	DDX_Control(pDX, IDC_BUTTON_SPACE_M, m_cbutton_space_m);
	DDX_Control(pDX, IDC_BUTTON_SYMBOL, m_cbutton_symbol);
	DDX_Control(pDX, IDC_COMBO_FONT, m_ccombo_font);
	DDX_Control(pDX, IDC_RICHEDIT, m_richedit);
	DDX_Control(pDX, IDC_CHECK_BOLD, m_check_bold);
	DDX_Control(pDX, IDC_COMBO_COLOR, m_ccombo_color);
	DDX_Control(pDX, IDC_BUTTON_INS, m_cbutton_ins);
	DDX_Control(pDX, IDC_COMBO_ROTATE, m_ccombo_rotation);
	DDX_Control(pDX, IDC_COMBO_HEIGHT, m_ccombo_height);
	DDX_Control(pDX, IDCANCEL, m_cbutton_cancel);
	DDX_Control(pDX, IDC_COMBO_STYLE, m_ccombo_style);
	DDX_Control(pDX, IDC_BUTTON_UNDO, m_cbutton_undo);
	DDX_Control(pDX, IDC_BUTTON_PROP, m_cbutton_prop);
	DDX_Control(pDX, IDC_BUTTON_PASTE, m_cbutton_paste);
	DDX_Control(pDX, IDC_BUTTON_EDIT, m_cbutton_edit);
	DDX_Control(pDX, IDC_BUTTON_CUT, m_cbutton_cut);
	DDX_Control(pDX, IDC_BUTTON_COPY, m_cbutton_copy);
	DDX_Control(pDX, IDC_RADIO_RIGHT, m_cradio_right);
	DDX_Control(pDX, IDC_RADIO_MIDLE, m_cradio_midle);
	DDX_Control(pDX, IDC_RADIO_LEFT, m_cradio_left);
	DDX_Control(pDX, IDC_CHECK_ITALIC, m_check_italic);
	DDX_Control(pDX, IDC_CHECK_UNDER, m_check_under);
	DDX_Control(pDX, IDC_STATIC_RE, m_cstatic_re);
	DDX_Control(pDX, IDC_STATIC_CAPS, m_cstatic_caps);
	DDX_Control(pDX, IDC_STATIC_NUM, m_cstatic_num);
	DDX_CBString(pDX, IDC_COMBO_STYLE, m_scombo_style);
	DDX_CBString(pDX, IDC_COMBO_HEIGHT, m_scombo_height);
	DDX_CBString(pDX, IDC_COMBO_ROTATE, m_scombo_rotation);
	DDX_Check(pDX, IDC_CHECK_BOLD, m_vcheck_bold);
	DDX_Check(pDX, IDC_CHECK_ITALIC, m_vcheck_italic);
	DDX_Check(pDX, IDC_CHECK_UNDER, m_vcheck_under);
	DDX_Text(pDX, IDC_RICHEDIT, m_srichedit);
	DDX_Check(pDX, IDC_BUTTON_COURSE, m_vcheck_course);
	DDX_Check(pDX, IDC_BUTTON_LOOK, m_vcheck_look);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(MStringDlg, CDialog)
	//{{AFX_MSG_MAP(MStringDlg)
	ON_WM_SYSCOMMAND()
	ON_BN_CLICKED(IDC_BUTTON_PROP, OnButtonProp)
	ON_WM_PAINT()
	ON_CBN_SELENDOK(IDC_COMBO_STYLE, OnSelendokComboStyle)
	ON_CBN_SELENDOK(IDC_COMBO_HEIGHT, OnSelendokComboHeight)
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_BUTTON_EDIT, OnButtonEdit)
	ON_BN_CLICKED(IDC_BUTTON_UNDO, OnButtonUndo)
	ON_BN_CLICKED(IDC_BUTTON_CUT, OnButtonCut)
	ON_BN_CLICKED(IDC_BUTTON_COPY, OnButtonCopy)
	ON_BN_CLICKED(IDC_BUTTON_PASTE, OnButtonPaste)
	ON_BN_CLICKED(IDC_RADIO_LEFT, OnRadioLeft)
	ON_BN_CLICKED(IDC_RADIO_MIDLE, OnRadioMidle)
	ON_BN_CLICKED(IDC_RADIO_RIGHT, OnRadioRight)
	ON_BN_CLICKED(IDC_BUTTON_INS, OnButtonIns)
	ON_CBN_EDITCHANGE(IDC_COMBO_ROTATE, OnEditchangeComboRotate)
	ON_CBN_SELENDOK(IDC_COMBO_ROTATE, OnSelendokComboRotate)
	ON_CBN_SELENDOK(IDC_COMBO_COLOR, OnSelendokComboColor)
	ON_BN_CLICKED(IDC_CHECK_ITALIC, OnCheckItalic)
	ON_BN_CLICKED(IDC_CHECK_UNDER, OnCheckUnder)
	ON_BN_CLICKED(IDC_CHECK_BOLD, OnCheckBold)
	ON_CONTROL(ENM_CHANGE, IDC_RICHEDIT, OnDraw)
	ON_CBN_SELENDOK(IDC_COMBO_FONT, OnSelendokComboFont)
	ON_CONTROL(ENM_SELCHANGE, IDC_RICHEDIT, OnSelChange)
	ON_BN_CLICKED(IDC_BUTTON_SYMBOL, OnButtonSymbol)
	ON_BN_CLICKED(IDC_BUTTON_SPACE_P, OnButtonSpaceP)
	ON_BN_CLICKED(IDC_BUTTON_SPACE_M, OnButtonSpaceM)
	ON_CBN_SELENDOK(IDC_COMBO_SPACE_STYLE, OnSelendokComboSpaceStyle)
	ON_BN_CLICKED(IDC_BUTTON_X, OnButtonX)
	ON_BN_CLICKED(IDC_BUTTON_Y, OnButtonY)
	ON_BN_CLICKED(IDC_BUTTON_COURSE, OnButtonCourse)
	ON_EN_KILLFOCUS(IDC_EDIT_WIDTH, OnKillfocusEditWidth)
	ON_CBN_EDITCHANGE(IDC_COMBO_HEIGHT, OnEditchangeComboHeight)
	ON_BN_CLICKED(IDC_BUTTON_LOOK, OnButtonLook)
	ON_WM_SIZE()
	ON_WM_GETMINMAXINFO()
	ON_WM_DESTROY()
	ON_WM_CREATE()
	ON_WM_NCHITTEST()
	ON_WM_QUERYDRAGICON()
	ON_WM_CONTEXTMENU()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MStringDlg message handlers

BOOL MStringDlg::OnInitDialog() 
{
	CAcUiDialog::OnInitDialog();
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	//   
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	//   
	//   
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	//CString strAboutMenu;
	if(m_bRememberSize)
	{
		// Load the previous size of the dialog box from the INI/Registry
		CString dialog_name;
		GetDialogProfileEntry(dialog_name);

		int cx = AfxGetApp()->GetProfileInt(dialog_name,"CX",0);
		int cy = AfxGetApp()->GetProfileInt(dialog_name,"CY",0);
		
		if(cx && cy)
		{
			SetWindowPos( NULL, 0, 0, cx, cy, SWP_NOMOVE );
		}
	}

	//AVBCDemo cl;
	//int bl = cl.ctrl();
	
	pSysMenu->AppendMenu(MF_SEPARATOR);
	pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, " ..");

	hBitmap_cut.LoadBitmap(IDB_BITMAP_CUT);
	hBitmap_copy.LoadBitmap(IDB_BITMAP_COPY);
	hBitmap_paste.LoadBitmap(IDB_BITMAP_PASTE);
	hBitmap_left.LoadBitmap(IDB_BITMAP_LEFT);
	hBitmap_midle.LoadBitmap(IDB_BITMAP_MIDLE);
	hBitmap_right.LoadBitmap(IDB_BITMAP_RIGHT);
	hBitmap_prop.LoadBitmap(IDB_BITMAP_PROP);
	hBitmap_cancel.LoadBitmap(IDB_BITMAP_CANCEL);
	hBitmap_edit.LoadBitmap(IDB_BITMAP_EDIT);
	hBitmap_undo.LoadBitmap(IDB_BITMAP_UNDO);
	hBitmap_ins.LoadBitmap(IDB_BITMAP_INS);
	hBitmap_bold.LoadBitmap(IDB_BITMAP_BOLD);
	hBitmap_italic.LoadBitmap(IDB_BITMAP_ITALIC);
	hBitmap_under.LoadBitmap(IDB_BITMAP_UNDER);
	hBitmap_color.LoadBitmap(IDB_BITMAP_COLOR);
	hBitmap_space_m.LoadBitmap(IDB_BITMAP_SPACE_M);
	hBitmap_space_p.LoadBitmap(IDB_BITMAP_SPACE_P);
	hBitmap_font.LoadBitmap(IDB_BITMAP_FONT);
	hBitmap_course.LoadBitmap(IDB_BITMAP_COURSE);
	hBitmap_plus.LoadBitmap(IDB_BITMAP_X);
	hBitmap_minus.LoadBitmap(IDB_BITMAP_Y);
	hBitmap_look.LoadBitmap(IDB_BITMAP_LOOK);


	m_cbutton_cut.SetBitmap(hBitmap_cut);
	m_cbutton_copy.SetBitmap(hBitmap_copy);
	m_cbutton_paste.SetBitmap(hBitmap_paste);
	m_cradio_left.SetBitmap(hBitmap_left);
	m_cradio_midle.SetBitmap(hBitmap_midle);
	m_cradio_right.SetBitmap(hBitmap_right);
	m_cbutton_prop.SetBitmap(hBitmap_prop);
	m_cbutton_cancel.SetBitmap(hBitmap_cancel);
	m_cbutton_edit.SetBitmap(hBitmap_edit);
	m_cbutton_undo.SetBitmap(hBitmap_undo);
	m_cbutton_help.SetBitmap(hBitmap_help);
	m_cbutton_ins.SetBitmap(hBitmap_ins);
	m_check_bold.SetBitmap(hBitmap_bold);
	m_check_italic.SetBitmap(hBitmap_italic);
	m_check_under.SetBitmap(hBitmap_under);
	m_cbutton_space_m.SetBitmap(hBitmap_space_m);
	m_cbutton_space_p.SetBitmap(hBitmap_space_p);
	m_cbutton_symbol.SetBitmap(hBitmap_font);
	m_cbutton_course.SetBitmap(hBitmap_course);
	m_cbutton_plus.SetBitmap(hBitmap_plus);
	m_cbutton_minus.SetBitmap(hBitmap_minus);
	m_cbutton_look.SetBitmap(hBitmap_look);




	m_richedit.SubclassDlgItem(IDC_RICHEDIT, this);
	m_richedit.SetEventMask(ENM_CHANGE | ENM_SELCHANGE | WM_RBUTTONDOWN );
	toolTip();

	/*m_richedit.GetSystemFonts(m_richedit.m_saFontList);
	for (int i = 0;i<m_richedit.m_saFontList.GetSize();i++)
		m_ccombo_font.AddString(m_richedit.m_saFontList.GetAt(i));*/

	m_ccombo_font.InitFonts();
	
	mglstring.permit=TRUE;

	
	AcDbTextStyleTable* pStyleTable;
	acdbHostApplicationServices()->workingDatabase()->getTextStyleTable(pStyleTable,
		AcDb::kForRead);
	AcDbTextStyleTableIterator* pIterator;
	pStyleTable->newIterator(pIterator);
	AcDbTextStyleTableRecord *pStyle;
	char * name;
	for( ; !pIterator->done(); pIterator->step())
	{
		pIterator->getRecord(pStyle, AcDb::kForRead);

		pStyle->getName(name);
		
		
		if(name == NULL)
			continue;
		m_ccombo_style.AddString(name);
		pStyle->close();
	}
	delete pIterator;
	pStyleTable->close();
	m_ccombo_angle.AddString("0");
	m_ccombo_angle.AddString("15");

	m_ccombo_rotation.AddString("0");
	m_ccombo_rotation.AddString("90");

	m_ccombo_height.AddString("1.8");
	m_ccombo_height.AddString("2.5");
	m_ccombo_height.AddString("3.5");
	m_ccombo_height.AddString("5");
	m_ccombo_height.AddString("7");
	m_ccombo_height.AddString("10");
	m_ccombo_height.AddString("18");

	m_ccombo_space_style.AddString(" ");
	m_ccombo_space_style.AddString("");
	if (mglstring.lspstyle==AcDb::kAtLeast)
		m_ccombo_space_style.SetWindowText(" ");
	else if (mglstring.lspstyle==AcDb::kExactly)
		m_ccombo_space_style.SetWindowText("");

	mglstring.course=2;
	m_vcheck_look=TRUE;

	if (mglstring.lineSpace==NULL)
		mglstring.lineSpace=1;
	m_vedit_width.m_valText="1 2 3 4 5 6 7 8 9 0  .";
	m_vedit_width.bl=TRUE;


	subOnInitDialog();

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


 



void MStringDlg::OnButtonProp() 
{
	BeginEditorCommand();
	ShowWindow(SW_HIDE);
	InfoDlg dbox(acedGetAcadDwgView());
	dbox.DoModal();
	CompleteEditorCommand();
	delete m_pToolTip;
	toolTip();

	ShowWindow(SW_SHOW);	
}

void MStringDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		BeginEditorCommand();
		ShowWindow(SW_HIDE);
		InfoDlg dbox(acedGetAcadDwgView());
		dbox.DoModal();
		CompleteEditorCommand();
		delete m_pToolTip;
		toolTip();

		ShowWindow(SW_SHOW);	
	}
	else
		CDialog::OnSysCommand(nID, lParam);
}

void MStringDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	if(m_bDrawGripper)
	{
		CRect rc;
		GetClientRect(rc);

		rc.left = rc.right-GetSystemMetrics(SM_CXHSCROLL);
		rc.top = rc.bottom-GetSystemMetrics(SM_CYVSCROLL);
		m_GripperRect = rc;
		CClientDC dc(this);
		dc.DrawFrameControl(rc,DFC_SCROLL,DFCS_SCROLLSIZEGRIP);
	}

	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}	
	
	// Do not call CDialog::OnPaint() for painting messages
}


BOOL MStringDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
			if (NULL != m_pToolTip)
	        m_pToolTip->RelayEvent(pMsg);
	
			fnCapsDown();
			fnNumLock();
			LayoutName();
	

					
	return CDialog::PreTranslateMessage(pMsg);
}


BOOL MStringDlg::fnCapsDown()
{
BYTE keys[256];
BOOL fCapsDown=GetKeyboardState(keys)? TRUE :FALSE;
if (keys[20]==1)
{
	m_cstatic_caps.SetWindowText("CAP");
	return TRUE;
}
else
{
	m_cstatic_caps.SetWindowText("");
	return FALSE;
}
}

BOOL MStringDlg::fnNumLock()
{
BYTE keys[256];
BOOL fNumLock=GetKeyboardState(keys)? TRUE :FALSE;
if (keys[144]==1)
{

	m_cstatic_num.SetWindowText("NUM");
	return TRUE;
}
else
{
	m_cstatic_num.SetWindowText("");
	return FALSE;
}
}

BOOL MStringDlg::LayoutName()
{
char a[255];
LPTSTR pwszKLID=a;

BOOL bl=GetKeyboardLayoutName(
     pwszKLID 	// address of buffer for layout name
   );

CString s;
s.Format("%s",pwszKLID);
s=s.Right(3);

if (s=="419")
{
	m_cstatic_re.SetWindowText("RUS");
	return TRUE;
}
else if(s=="409")
{
	m_cstatic_re.SetWindowText("LAT");
	return FALSE;
}
return FALSE;
}

void MStringDlg::subOnInitDialog()
{
	
	if (mglstring.horizontalMode == AcDb::kTextLeft) {
	m_cradio_left.SetState(TRUE);
	}
	else if (mglstring.horizontalMode == AcDb::kTextCenter) {
	m_cradio_midle.SetState(TRUE);
	}
	else if (mglstring.horizontalMode == AcDb::kTextRight) {
	m_cradio_right.SetState(TRUE);
	}
	
	m_scombo_rotation.Format("%i",(int)(mglstring.rotation* 180 / PI));
	styleId=getTextStyleId(mglstring.textStyle);
	if (!styleId)
		 {	
			 getSysVar("TEXTSTYLE", mglstring.textStyle);
		     styleId=getTextStyleId(mglstring.textStyle);
		 }
	
	m_scombo_style=mglstring.textStyle;
	m_ccombo_style.SelectString( -1, m_scombo_style);
	
	TCHAR tmpStr[100];

	if (!mglstring.height)
	{
		double valdblSize;
		getSysVar("TEXTSIZE", valdblSize);
		acdbRToS(valdblSize, -1,-1, tmpStr);
		m_scombo_height=tmpStr;
		
		if(m_scombo_height.Find(".")==-1) m_scombo_height+=".0";
		
	}
	else
	{
		acdbRToS(mglstring.height , -1,-1, tmpStr);
		m_scombo_height=tmpStr;
		if(m_scombo_height.Find(".")==-1) m_scombo_height+=".0";
	}

	UpdateData(FALSE);

	m_richedit.SetFontSize(atof(m_scombo_height)*6,FALSE);
	m_richedit.SetFontSize(atof(m_scombo_height)*6,TRUE);
	m_richedit.SetSel(0,m_srichedit.GetLength());
	m_richedit.SetBackgroundColor(0,m_ccombo_color.GetColorFromIndex(0));
	
	if (mglstring.edit ==TRUE)
	{
		m_richedit.SetRTF(mglstring.RTF );
		mglstring.edit =FALSE;
	}
	
	CString mw;
	mw.Format("%f",mglstring.widthFactor);
	int p;
	p=mw.Find(".");
	if(p!=-1)
	mw=mw.Left(p+2);

	m_vedit_width.SetWindowText(mw);
	OnSelendokComboColor() ;
	if(mglstring.buy==2)
	{
		BeginEditorCommand();
		ShowWindow(SW_HIDE);
		InfoDlg dbox(acedGetAcadDwgView());
		dbox.DoModal();
		CompleteEditorCommand();
		delete m_pToolTip;
		toolTip();
		ShowWindow(SW_SHOW);
	}


}



void MStringDlg::OnSelendokComboStyle() 
{
	//UpdateData(TRUE);
	int nSelected = m_ccombo_style.GetCurSel() ;
	CString cs;
	if ( nSelected >= 0 )
		{
		
		m_ccombo_style.GetLBText ( nSelected, cs) ;
		mglstring.textStyle = cs;
		styleId=getTextStyleId(cs);

		}
	
	draw();
	
	m_richedit.SetFocus();
	
}

void MStringDlg::OnSelendokComboHeight() 
{
	int nSelected = m_ccombo_height.GetCurSel() ;
	if ( nSelected >= 0 )
		{
		CString cs;
		m_ccombo_height.GetLBText ( nSelected, cs); 
		m_richedit.SetFontSize(atof(cs)*6,FALSE);
		mglstring.height  =  atof(cs);
		
		}
	m_richedit.SetFocus();

}


void MStringDlg::change()
{
	
	UpdateData(TRUE);
	AcDbEntity* pEnt=NULL;
	AcDbObjectId objId;
	AcDbMText* pMText;
	AcDbDimension* pDim;
	mglstring.string=(const char*) acadText;

		acdbGetObjectId(objId, mglstring.name );
		acdbOpenObject(pEnt, objId, AcDb::kForWrite);
		if (pEnt->isKindOf(AcDbMText::desc()))
		{
			pMText = AcDbMText::cast(pEnt);
			pMText->setContents(mglstring.string);
			pMText->setTextHeight(mglstring.height);
			pMText->setRotation(mglstring.rotation);
			pMText->setTextStyle(styleId);
			pMText->setHorizontalMode(mglstring.horizontalMode);
			pMText->setAlignmentPoint(mglstring.position );
			pMText->setLocation(mglstring.position);
			pMText->setLineSpacingStyle(mglstring.lspstyle);
			pMText->setLineSpacingFactor(mglstring.lineSpace);
			pMText->setWidth(mglstring.widthFactor);
			pEnt->close();
			if (m_scombo_style != "")
				mglstring.textStyle =m_scombo_style;
			else
				getTextStyleName(mglstring.textStyle,styleId);
			refresh();
			}
		else if (pEnt->isKindOf(AcDbDimension::desc()))
		{
			
			pDim = AcDbDimension::cast(pEnt);
			if(mglstring.dim==TRUE)
			{
				CString s=mglstring.string;
				s.MakeReverse();
				int ir=s.Find("P\\");
				int is=s.GetLength()-ir-3;
				s.MakeReverse();
				s=s.Left(is);
				mglstring.string=s;
				int iz;
				iz=s.Find(";");

				if (iz==s.GetLength()-2)
					mglstring.string="";

			}
			CString s=mglstring.string;
			s=s.Left(s.GetLength()-1);
			if (s!="")
				s+="}}";
		pDim->setDimensionText(s);
			
			pEnt->close();
			refresh();
		    
		}	

		else
		{
			pEnt->close();
		    return;
		}	
	
}

void MStringDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
m_richedit.SetFocus();
	
}


void MStringDlg::OnButtonEdit() 
{

	CString s;
	AcToRtf ar;

	if (mglstring.permit==FALSE)
	{
		s=m_richedit.GetRTF();
		acadText=ar.format(s);
		change();
	}

	BeginEditorCommand();
	ShowWindow(SW_HIDE);
	if(mglstring.dim==FALSE)
		entErase(mglstring.name);
	m_srichedit="";
	int result=100;
		while (result!=0)
		{
			do{
			result =select();
			if (result==1)
				{CDialog::OnCancel();
			return ;}
			} while (result == 2 );

		}
	
	UpdateData(FALSE);
	subOnInitDialog();
	CompleteEditorCommand();
	delete m_pToolTip;
	toolTip();
	ShowWindow(SW_SHOW);
	refresh();

    return ;	
}

bool MStringDlg::entErase(ads_name name)
{
	AcDbEntity* pEnt=NULL;
	AcDbObjectId objId;

	if( m_srichedit=="")
	{
		acdbGetObjectId(objId,name );
		acdbOpenObject(pEnt, objId, AcDb::kForWrite);
		if (pEnt->isKindOf(AcDbMText::desc()))
		{
			pEnt->erase();
			pEnt->close();
		}
	}
	mglstring.string=_T("");
return TRUE;
}


void MStringDlg::OnButtonUndo() 
{
	m_richedit.Undo();
}



void MStringDlg::OnButtonCut() 
{
m_richedit.Cut();	
}

void MStringDlg::OnButtonCopy() 
{
m_richedit.Copy();	
}

void MStringDlg::OnButtonPaste() 
{

int k=m_richedit.IsClipboard();
 if (k!=0)
	{
		RestoreWaitCursor();
		BeginWaitCursor();
		

		long nStartChar, nEndChar;
		m_richedit.GetSel(nStartChar,nEndChar);
		mglstring.pst=TRUE;
		m_richedit.Paste();	
		m_richedit.SetSel(nStartChar,nStartChar+k);
		m_richedit.SetSel(nStartChar+k,nStartChar+k);

		mglstring.pst=FALSE;
		EndWaitCursor();
		m_richedit.SetFocus();
	}


}
void MStringDlg::OnDraw() 
{
		if(mglstring.permit==TRUE)
			draw();
}
void MStringDlg::OnSelChange()
{
	long nStartChar,nEndChar;
	m_richedit.GetSel(nStartChar,nEndChar);
	if(((nEndChar-nStartChar)!=0)&&(mglstring.pst==TRUE))
	{

		PARAFORMAT pf ;
		pf=m_richedit.GetParagraphFormat();
		pf.cbSize = sizeof(PARAFORMAT);
		pf.dwMask = PFM_NUMBERING ;
		pf.cTabCount = MAX_TAB_STOPS;
		
		for( int itab = 0 ; itab < pf.cTabCount  ; itab++ )
		{
				pf.wNumbering = 0;
				pf.dxOffset = 0;
				pf.dxStartIndent = 0;
				pf.dwMask = PFM_NUMBERING | PFM_STARTINDENT | PFM_OFFSET;
	
		
		}
		m_richedit.SetParaFormat(pf);
	}

	/*m_richedit.GetRect(&Rect);
	Rect.right=3.5*(LONG)mglstring.widthFactor;
	m_richedit.SetRect(&Rect);*/

	
	setOptions();

	
}
void MStringDlg::OnRadioLeft() 
{
	mglstring.horizontalMode = AcDb::kTextLeft;
	m_cradio_midle.SetState(FALSE);
	m_cradio_right.SetState(FALSE);
		change();
	//m_richedit.SetParagraphLeft();
	m_richedit.SetFocus();	
	
}

void MStringDlg::OnRadioMidle() 
{
	
	mglstring.horizontalMode = AcDb::kTextCenter;
	m_cradio_left.SetState(FALSE);
	m_cradio_right.SetState(FALSE);
		//m_richedit.SetParagraphCenter();

		change();

	m_richedit.SetFocus();	
}

void MStringDlg::OnRadioRight() 
{
	mglstring.horizontalMode = AcDb::kTextRight;
	m_cradio_left.SetState(FALSE);
	m_cradio_midle.SetState(FALSE);
		change();
		//m_richedit.SetParagraphRight();
		m_richedit.SetFocus();
	
}



void MStringDlg::OnButtonIns() 
{
	CString s;
	AcToRtf ar;

	if(mglstring.permit==FALSE)
	{
		s=m_richedit.GetRTF();
		acadText=ar.format(s);
		change();
	}

	AcGePoint3d basePoint;
	basePoint=mglstring.position;
	mglstring.string ="";
	if(mglstring.dim==FALSE)
		entErase(mglstring.name);
	BeginEditorCommand();
	ShowWindow(SW_HIDE);

	int result = acedGetPoint(asDblArray(basePoint) ,"\n  : ",
	asDblArray(mglstring.position) ); 
	if (result != RTNORM) { 
		CDialog::OnCancel();
		return ; } 
	m_srichedit ="";
	createString(mglstring.string );
	m_richedit.SetFocus();	
	UpdateData(FALSE);
	subOnInitDialog();
	CompleteEditorCommand();
	delete m_pToolTip;
	toolTip();

	ShowWindow(SW_SHOW);
	refresh();
	
}


void MStringDlg::toolTip()
{
		m_pToolTip = new CToolTipCtrl;
		m_pToolTip->Create(this);

	   //      
	 m_pToolTip->AddTool(&m_cbutton_cut, "");
	 m_pToolTip->AddTool(&m_cbutton_copy, "");
	 m_pToolTip->AddTool(&m_cbutton_paste, "");
	 m_pToolTip->AddTool(&m_cradio_left, " ");
	 m_pToolTip->AddTool(&m_cradio_midle, " ");
	 m_pToolTip->AddTool(&m_cradio_right, " ");
	 m_pToolTip->AddTool(&m_cbutton_ins, "  ");
	 m_pToolTip->AddTool(&m_cbutton_prop, " ");
	 m_pToolTip->AddTool(&m_cbutton_cancel, "");
	 m_pToolTip->AddTool(&m_ccombo_style, "");
	 m_pToolTip->AddTool(&m_ccombo_height, " ");
	 m_pToolTip->AddTool(&m_ccombo_angle, " ");
	 m_pToolTip->AddTool(&m_ccombo_rotation, " ");
	 m_pToolTip->AddTool(&m_cbutton_undo, "");
	 m_pToolTip->AddTool(&m_cbutton_edit, " ");
	 m_pToolTip->AddTool(&m_cbutton_help, ""); 
	 m_pToolTip->AddTool(&m_check_bold, "");
	 m_pToolTip->AddTool(&m_check_italic, ""); 
	 m_pToolTip->AddTool(&m_check_under, ""); 
	 m_pToolTip->AddTool(&m_ccombo_color, " "); 
	 m_pToolTip->AddTool(&m_cbutton_space_m, "  "); 
	 m_pToolTip->AddTool(&m_cbutton_space_p, "  "); 
	 m_pToolTip->AddTool(&m_cbutton_symbol, "  (   \"ttf\")");
	 m_pToolTip->AddTool(&m_ccombo_font, "");
	 m_pToolTip->AddTool(&m_ccombo_space_style, " ");
	 m_pToolTip->AddTool(&m_cbutton_course, "  ");
	 m_pToolTip->AddTool(&m_cbutton_plus, "  X");
	 m_pToolTip->AddTool(&m_cbutton_minus, "  Y");
	 m_pToolTip->AddTool(&m_cbutton_look, "  /");
	 m_pToolTip->AddTool(&m_vedit_width, " ");

	 m_pToolTip->Activate(TRUE);
}

MStringDlg::~MStringDlg()
{
delete m_pToolTip;
}








void MStringDlg::OnSelendokComboRotate() 
{
	
	int nSelected = m_ccombo_rotation.GetCurSel() ;
	if ( nSelected >= 0 )
		{
		CString cs;
		m_ccombo_rotation.GetLBText ( nSelected, cs); 
			mglstring.rotation = PI/180* atof(cs);
			
		}
	
	change();
	
	m_richedit.SetFocus();	

}
void MStringDlg::OnEditchangeComboRotate() 
{
	UpdateData();
	mglstring.rotation = PI/180* atof(m_scombo_rotation);
	
	change();
}



CString MStringDlg::GetLong(long l)
{
	CString sResult;
	sResult.Format(_T("%i,"), l);
	return sResult;
}



void MStringDlg::OnSelendokComboColor() 
{
	int nSelected = m_ccombo_style.GetCurSel() ;
	CString cs;
	if ( nSelected >= 0 )
		{
			int colorIndex=m_ccombo_color.GetCurrentItemColorIndex();
			

			COLORREF clr;
			if (colorIndex==256)
				clr=m_ccombo_color.GetColorFromIndex(m_ccombo_color.GetCurrentLayerColorIndex());
			else if (colorIndex==0)
			clr=m_ccombo_color.GetColorFromIndex(m_ccombo_color.GetBlockColorIndex());
			else
				clr=m_ccombo_color.GetColorFromIndex(colorIndex);

			CHARFORMAT cf = m_richedit.GetCharFormat();

			if (cf.dwEffects & CFE_AUTOCOLOR) cf.dwEffects -= CFE_AUTOCOLOR;
		

			
			cf.crTextColor = clr;

			cf.dwMask = CFM_COLOR;

			m_richedit.SetSelectionCharFormat(cf);
			
		
		}
	
	m_richedit.SetFocus();	
	
}


/*void MStringDlg::OnSelchangeComboColor() 
{
int colorIndex=m_ccombo_color.GetCurrentItemColorIndex();
	
COLORREF clr;
if (colorIndex==256)
	clr=m_ccombo_color.GetColorFromIndex(m_ccombo_color.GetCurrentLayerColorIndex());
else if (colorIndex==0)
	clr=m_ccombo_color.GetColorFromIndex(m_ccombo_color.GetBlockColorIndex());
else
	clr=m_ccombo_color.GetColorFromIndex(colorIndex);
CHARFORMAT cf = m_richedit.GetCharFormat();

if (cf.dwEffects & CFE_AUTOCOLOR) cf.dwEffects -= CFE_AUTOCOLOR;

cf.crTextColor = clr;

cf.dwMask = CFM_COLOR;
m_richedit.SetSelectionCharFormat(cf);
	
}*/



void MStringDlg::OnCheckItalic() 
{
CString s;
m_ccombo_font.GetWindowText(s);
if (s!="MS Sans Serif")
{
m_richedit.SetSelectionItalic();
m_richedit.SetFocus();
change();
}

}

void MStringDlg::OnCheckUnder() 
{
m_richedit.SetSelectionUnderlined();	
m_richedit.SetFocus();
change();


}

void MStringDlg::OnCheckBold() 
{
CString s;
m_ccombo_font.GetWindowText(s);
if (s!="MS Sans Serif")
{
m_richedit.SetSelectionBold();	
m_richedit.SetFocus();
change();
}	

}

void MStringDlg::draw()
{
		
		CString s;
		AcToRtf ar;
		static CString sold;
		s=m_richedit.GetRTF();
		if ((s.Find("\\pntext")==-1)&&(s!=sold))
		{
			acadText=ar.format(s);
			
			change();
		}
		sold=s;

}


void MStringDlg::OnRadioSpace() 
{
	mglstring.lineSpace = 1;
	m_cradio_spacing15x.SetState(FALSE);
	m_cradio_spacing2x.SetState(FALSE);
		change();
	m_richedit.SetFocus();	

}

void MStringDlg::OnRadioSpace15() 
{
	mglstring.lineSpace = 1.5;
	m_cradio_spacing1x.SetState(FALSE);
	m_cradio_spacing2x.SetState(FALSE);
		change();
	m_richedit.SetFocus();	

	
}

void MStringDlg::OnRadioSpace2() 
{
	mglstring.lineSpace = 2;
	m_cradio_spacing1x.SetState(FALSE);
	m_cradio_spacing15x.SetState(FALSE);
		change();
	m_richedit.SetFocus();	

	
}


void MStringDlg::OnSelendokComboFont() 
{
	int def=0;
	int nSelected = m_ccombo_font.GetCurSel() ;
	CString cs;
	if ( nSelected >= 0 )
	{
		CHARFORMAT cf;
		cf = m_richedit.GetCharFormat();
		cf.bCharSet=DEFAULT_CHARSET;
		m_richedit.SetSelectionCharFormat(cf);

		m_ccombo_font.GetLBText ( nSelected, cs) ;
		int ics=cs.Find("(");
		if (ics==-1)
			m_richedit.SetFontName(cs);
		else
		{
			m_richedit.SetFontName(cs.Left(ics-1));
			def=1;
		}

		m_richedit.SetFocus();
	}

	
}



void MStringDlg::setOptions()
{

int colorIndex;
COLORREF clr;
clr=m_richedit.getSelectionColor();
colorIndex=m_ccombo_color.GetColorIndex(clr);
if (colorIndex==256)
	clr=m_ccombo_color.GetColorFromIndex(m_ccombo_color.GetCurrentLayerColorIndex());
else if (colorIndex==0)
	clr=m_ccombo_color.GetColorFromIndex(m_ccombo_color.GetCurrentLayerColorIndex());
else
	clr=m_ccombo_color.GetColorFromIndex(colorIndex);
if (colorIndex==0)
{
	int colorIndex=m_ccombo_color.GetCurrentItemColorIndex();
		
	COLORREF clr;
	clr=m_ccombo_color.GetColorFromIndex(m_ccombo_color.GetCurrentLayerColorIndex());
	CHARFORMAT cf = m_richedit.GetCharFormat();

	if (cf.dwEffects & CFE_AUTOCOLOR) cf.dwEffects -= CFE_AUTOCOLOR;

	cf.crTextColor = clr;

	cf.dwMask = CFM_COLOR;
	m_richedit.SetSelectionCharFormat(cf);
}

int iItem=m_ccombo_color.FindItemByColorIndex(colorIndex);
m_ccombo_color.SetCurSel(iItem);

CString s;	
s.Format("%f",m_richedit.GetSelectionFontSize()/6);
int p=s.Find(".");
if(p!=-1)
s=s.Left(p+2);
m_ccombo_height.SetWindowText(s);

s=m_richedit.GetSelectionFontName();
iItem=m_ccombo_font.FindStringExact(-1,s);
if(iItem!=-1)
	m_ccombo_font.SetCurSel(iItem);
else
{
	//m_ccombo_font.AddString(s);
	//iItem=m_ccombo_font.FindStringExact(-1,s);
	m_ccombo_font.SetCurSel(-1);

}
}




LPCTSTR MStringDlg::colorToStr(int color, CString &str, bool convertStandard)
{
    color = abs(color);    // in case used from Layer table

    ASSERT((color >= 0) && (color <= 256));

    if (color == 0)
        str = _T("ByBlock");
    else if (color == 256)
        str = _T("ByLayer");
    else if (convertStandard) {
        if (color == 1)
            str = _T("Red");
        else if (color == 2)
            str = _T("Yellow");
        else if (color == 3)
            str = _T("Green");
        else if (color == 4)
            str = _T("Cyan");
        else if (color == 5)
            str = _T("Blue");
        else if (color == 6)
            str = _T("Magenta");
        else if (color == 7)
            str = _T("White/Black");
        else
		{
			str.Format("%i",color);
			str="Color "+str;
		}
    }
    else
	{
		str.Format("%i",color);
		str="Color "+str;
	}
        

    return str;
}


void MStringDlg::OnButtonSymbol() 
{
WinExec("Charmap.exe", SW_SHOW);	
}


COLORREF MStringDlg::getRGB(int colind)
{
	COLORREF  rgb;
	rgb=m_ccombo_color.GetColorFromIndex(colind);
return rgb;
}


void MStringDlg::OnButtonSpaceP() 
{

	if ((mglstring.lineSpace>=0.9)&&(mglstring.lineSpace<4))
	{
		mglstring.lineSpace += 0.01;
		change();
		m_richedit.SetFocus();	
	}
}

void MStringDlg::OnButtonSpaceM() 
{
	if ((mglstring.lineSpace>1)&&(mglstring.lineSpace<=4.1))
	{
		mglstring.lineSpace -= 0.01;
		change();
		m_richedit.SetFocus();	
	}
}

void MStringDlg::OnSelendokComboSpaceStyle() 
{

	int nSelected = m_ccombo_space_style.GetCurSel() ;
	if ( nSelected >= 0 )
		{
			CString cs;
			m_ccombo_space_style.GetLBText ( nSelected, cs); 
			if (cs==" ")
				mglstring.lspstyle = AcDb::kAtLeast ;
			else if (cs=="")
				mglstring.lspstyle = AcDb::kExactly ;
			change();	
		}

	
	m_richedit.SetFocus();		
}

void MStringDlg::move(int id)
{
	UpdateData(TRUE);
	//////////////////////////
	AcDbEntity* pEnt=NULL;
	AcDbObjectId objId;
		acdbGetObjectId(objId,mglstring.name );
		acdbOpenObject(pEnt, objId, AcDb::kForWrite);
		if (pEnt->isKindOf(AcDbMText::desc()))
		{
			pEnt->erase();
			pEnt->close();
		}
	/////////////////////////
		AcGePoint3d basePoint;
		basePoint=mglstring.position;
		if (m_vcheck_course==TRUE)
		{
			if (id==1)
				mglstring.position.x = mglstring.position.x + 0.5;
			else if(id==2)
				mglstring.position.y = mglstring.position.y + 0.5;
		}
		else
		{
			if (id==3)
				mglstring.position.x = mglstring.position.x - 0.5;
			else if(id==4)
				mglstring.position.y = mglstring.position.y - 0.5;
		}


	createString(mglstring.string );
	m_richedit.SetFocus();	
	UpdateData(FALSE);
	refresh();

}



void MStringDlg::OnButtonX() 
{
	if (mglstring.course==1)
		move(1);	
	else if (mglstring.course==2)
		move(3);
}

void MStringDlg::OnButtonY() 
{
	if (mglstring.course==1)
		move(2);	
	else if (mglstring.course==2)
		move(4);
	
}

void MStringDlg::OnButtonCourse() 
{
	if (m_vcheck_course==TRUE)
		mglstring.course=2;	
	else if (m_vcheck_course==FALSE)
		mglstring.course=1;
	
}



void MStringDlg::OnKillfocusEditWidth() 
{
	RestoreWaitCursor();
	BeginWaitCursor();

	CString s;
	m_vedit_width.GetWindowText(s);
	mglstring.widthFactor =atof(s);	
	CString snew;
	AcToRtf ar;
	snew=m_richedit.GetRTF();
	acadText=ar.format(snew);
	change();
	EndWaitCursor();
}

void MStringDlg::OnEditchangeComboHeight() 
{
 	CString s;
 	m_ccombo_height.GetWindowText(s);
 	m_richedit.SetFontSize(atof(s)*6,FALSE);
	mglstring.height  =  atof(s);
	
}

void MStringDlg::OnButtonLook() 
{
	UpdateData(TRUE);
	if (m_vcheck_look==TRUE)
	{
		AcToRtf ar;
		mglstring.permit=TRUE;
		CString s=m_richedit.GetRTF();
		acadText=ar.format(s);
		change();

	}
	else 
		mglstring.permit=FALSE;
	m_richedit.SetFocus();
}
/////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

void MStringDlg::SetControlInfo(WORD CtrlId,WORD Anchore)			
{
	if(Anchore == ANCHORE_LEFT)
		return; // Do nothing

	// Add resizing behaviour for the control
	DWORD c_info = CtrlId | (Anchore << 16);
	m_control_info.Add(c_info);
}


void MStringDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	if(nType == SIZE_MINIMIZED)
		return;

	int dx = cx - m_old_cx;
	int dy = cy - m_old_cy;

	if(m_old_cx)
	{
		// Move and Size the controls using the information
		// we got in SetControlInfo()
		//
		m_bSizeChanged = TRUE;
		CRect WndRect;
		CWnd *pWnd;
		DWORD c_info;
		short Anchore;
		for(int i = 0; i < m_control_info.GetSize(); i++)
		{
			c_info = m_control_info[i];
			pWnd = GetDlgItem(LOWORD(c_info));
			if(!pWnd)
			{
				TRACE("Control ID - %d NOT FOUND!!\n",LOWORD(c_info));
				continue;
			}

			if(!HIWORD(c_info))
				continue; // do nothing if anchored to top and or left

			Anchore = HIWORD(c_info);
			pWnd->GetWindowRect(&WndRect);  ScreenToClient(&WndRect);
			
			if(Anchore & RESIZE_HOR)
				WndRect.right += dx;
			else if(Anchore & ANCHORE_RIGHT)
				WndRect.OffsetRect(dx,0);

			if(Anchore & RESIZE_VER)
				WndRect.bottom += dy;
			else if(Anchore & ANCHORE_BOTTOM)
				WndRect.OffsetRect(0,dy);

			pWnd->MoveWindow(&WndRect);
		}

	}
	m_old_cx = cx;
	m_old_cy = cy;

	// When enlarging a dialog box we need to erase the old gripper 
	if(m_bDrawGripper)
		InvalidateRect(m_GripperRect);
}


void MStringDlg::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
{
    if (!m_minWidth) // first time
		{
		CDialog::OnGetMinMaxInfo(lpMMI);
		return;
		}
    lpMMI->ptMinTrackSize.x = m_minWidth;
    lpMMI->ptMinTrackSize.y = m_minHeight;
}

void MStringDlg::OnDestroy() 
{
	// Save the size of the dialog box, so next time
	// we'll start with this size
	if(m_bRememberSize && m_bSizeChanged && m_old_cx && m_old_cy)
		{
		CRect rc;
		GetWindowRect(&rc);
		CString dialog_name;
		GetDialogProfileEntry(dialog_name);

		AfxGetApp()->WriteProfileInt(dialog_name,"CX",rc.Width());
		AfxGetApp()->WriteProfileInt(dialog_name,"CY",rc.Height());
		}

	// Important: Reset the internal values in case of reuse of the dialog
	// with out deleting.
	m_minWidth = m_minHeight = m_old_cx = m_old_cy = 0;
	m_bSizeChanged = FALSE;

	CDialog::OnDestroy();
}


//
// OnCreate()
//
int MStringDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// Remember the original size so later we can calculate
	// how to place the controls on dialog Resize
	m_minWidth  = lpCreateStruct->cx;
	m_minHeight = lpCreateStruct->cy;
	return 0;
}

//
// OnPaint()
// Override WM_PAINT to draw a gripper
//
// Credit goes to: Tommy Svensson
//


//
// OnNcHitTest
// Handle mouse over the gripper
//
// Credit: Tommy Svensson
//
UINT MStringDlg::OnNcHitTest(CPoint point)
{
	UINT ht = CDialog::OnNcHitTest(point);

	if(ht==HTCLIENT && m_bDrawGripper)
	{
		CRect rc;
		GetWindowRect( rc );
		rc.left = rc.right-GetSystemMetrics(SM_CXHSCROLL);
		rc.top = rc.bottom-GetSystemMetrics(SM_CYVSCROLL);
		if(rc.PtInRect(point))
		{
			ht = HTBOTTOMRIGHT;
		}
	}
	return ht;
}


//
// GetDialogProfileEntry()
// Override this (virtual) function in your derived class
// if you want to store the dialog info under a different entry name.
//
// Credit: Ari Greenberg
void MStringDlg::GetDialogProfileEntry(CString &sEntry)
{
	// By default store the size under the Dialog ID value (Hex)
	sEntry.Format("%x",m_nIDTemplate);
}



void MStringDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	CString s;
	AcToRtf ar;

	if(mglstring.permit==FALSE)
	{
		s=m_richedit.GetRTF();
		acadText=ar.format(s);
		change();
	}
	if(mglstring.dim==FALSE)
		entErase(mglstring.name);
	if(mglstring.buy==2)
	{
		BeginEditorCommand();
		ShowWindow(SW_HIDE);
		InfoDlg dbox(acedGetAcadDwgView());
		dbox.DoModal();
		CompleteEditorCommand();
		delete m_pToolTip;
		toolTip();
		ShowWindow(SW_SHOW);	
	}	
	//CDialog::OnOK();	

	CAcUiDialog::OnCancel();
}


