#if !defined(AFX_MSTRINGDLG_H__2C27D519_B641_4F4E_969C_90A5DD576F4A__INCLUDED_)
#define AFX_MSTRINGDLG_H__2C27D519_B641_4F4E_969C_90A5DD576F4A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MStringDlg.h : header file
//
#include "resource.h"
#include "AutoRichEditCtrl.h"
#include <adui.h>
#include <acui.h>
#include "MStringDlg.h"
#include <AVBedit.h>
#include "FontCombo.h"
#define ANCHORE_LEFT	0x0000
#define ANCHORE_TOP		0x0000
#define ANCHORE_RIGHT	0x0001
#define ANCHORE_BOTTOM	0x0002
#define	RESIZE_HOR		0x0004
#define	RESIZE_VER		0x0008
#define	RESIZE_BOTH		(RESIZE_HOR | RESIZE_VER)

/////////////////////////////////////////////////////////////////////////////
// MStringDlg dialog

class MStringDlg : public CAcUiDialog
{
// Construction
public:
	void move(int id);
	COLORREF getRGB(int colind);
	LPCTSTR colorToStr(int color, CString& str, bool convertStandard);
	CFont m_font;
	void draw();
	void change();

	
	MStringDlg(CWnd* pParent = NULL);   // standard constructor
	virtual	~MStringDlg();
	CToolTipCtrl* m_pToolTip;
	
	void SetControlInfo(WORD CtrlId,WORD Anchore);
	BOOL GetRememberSize() { return  m_bRememberSize;}
	void SetRememberSize(BOOL bRemember) { m_bRememberSize = bRemember;}
	virtual void GetDialogProfileEntry(CString &sEntry);
protected:
	BOOL	m_bRememberSize;
	BOOL	m_bDrawGripper;
private:
	int		m_minWidth,m_minHeight;
	int		m_old_cx,m_old_cy;
	BOOL	m_bSizeChanged;
	CDWordArray	m_control_info;
	UINT	m_nIDTemplate;
	CRect	m_GripperRect;

// Dialog Data
	//{{AFX_DATA(MStringDlg)
	enum { IDD = IDD_DIALOG_MTEXT };
	CButton	m_cbutton_look;
	CAVBEdit	m_vedit_width;
	CButton	m_cbutton_course;
	CButton	m_cbutton_minus;
	CButton	m_cbutton_plus;
	CComboBox	m_ccombo_space_style;
	CButton	m_cbutton_space_p;
	CButton	m_cbutton_space_m;
	CButton	m_cbutton_symbol;
	CFontCombo	m_ccombo_font;
	CButton	m_cbutton_font;
	CAutoRichEditCtrl	m_richedit;
	CButton	m_check_bold;
	CAcUiColorComboBox	m_ccombo_color;
	CButton	m_cbutton_color;
	CButton	m_cbutton_ins;
	CComboBox	m_ccombo_rotation;
	CComboBox	m_ccombo_height;
	CComboBox	m_ccombo_angle;
	CButton	m_cbutton_cancel;
	CComboBox m_ccombo_style;
	CButton	m_cbutton_undo;
	CButton	m_cbutton_prop;
	CButton	m_cbutton_paste;
	CButton	m_cbutton_help;
	CButton	m_cbutton_edit;
	CButton	m_cbutton_cut;
	CButton	m_cbutton_copy;
	CButton	m_cradio_right;
	CButton	m_cradio_midle;
	CButton	m_cradio_left;
	CButton	m_cradio_spacing1x;
	CButton	m_cradio_spacing15x;
	CButton	m_cradio_spacing2x;
	CButton	m_check_boold;
	CButton	m_check_italic;
	CButton	m_check_under;
	CStatic	m_cstatic_re;
	CStatic	m_cstatic_caps;
	CStatic	m_cstatic_num;
	CString	m_scombo_style;
	CString	m_scombo_height;
	CString	m_scombo_rotation;
	CString	m_scombo_angle;
	CString	m_sEdit;
	BOOL	m_vcheck_bold;
	BOOL	m_vcheck_italic;
	BOOL	m_vcheck_under;
	CString	m_srichedit;
	BOOL	m_vcheck_course;
	BOOL	m_vcheck_look;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(MStringDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
	private:
	CBitmap hBitmap_cancel;
	//CBitmap hBitmap_ins;

	//CBitmap hBitmap_dist;
	CBitmap hBitmap_prop;
	CBitmap hBitmap_right;
	CBitmap hBitmap_midle;
	CBitmap hBitmap_left;
	CBitmap hBitmap_paste;
	CBitmap hBitmap_copy;
	CBitmap hBitmap_cut;
	CBitmap hBitmap_edit;
	CBitmap hBitmap_undo;
	CBitmap hBitmap_ul;
	CBitmap hBitmap_re;
	CBitmap hBitmap_help;
	CBitmap hBitmap_ins;
	CBitmap hBitmap_bold;
	CBitmap hBitmap_italic;
	CBitmap hBitmap_under;
	CBitmap hBitmap_color;
	CBitmap hBitmap_space_m;
	CBitmap hBitmap_space_p;
	CBitmap hBitmap_font;
	CBitmap hBitmap_course;
	CBitmap hBitmap_plus;
	CBitmap hBitmap_minus;
	CBitmap hBitmap_look;


// Implementation
protected:
	
	void setOptions();
	CString acadText;
		
	CString m_text;
	CString GetLong(long l);
	void toolTip();
	bool entErase(ads_name name);
	void subOnInitDialog();
	BOOL LayoutName();
	BOOL fnNumLock();
	BOOL fnCapsDown();
	HICON m_hIcon;
	CString sCaption;


	// Generated message map functions
	//{{AFX_MSG(MStringDlg)
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	virtual BOOL OnInitDialog();
	afx_msg void OnButtonProp();
	afx_msg void OnPaint();
	afx_msg void OnSelendokComboStyle();
	afx_msg void OnSelendokComboHeight();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnButtonEdit();
	afx_msg void OnButtonUndo();
	afx_msg void OnButtonCut();
	afx_msg void OnButtonCopy();
	afx_msg void OnButtonPaste();
	afx_msg void OnRadioLeft();
	afx_msg void OnRadioMidle();
	afx_msg void OnRadioRight();
	afx_msg void OnButtonIns();
	afx_msg void OnEditchangeComboRotate();
	afx_msg void OnSelendokComboRotate();
	afx_msg void OnSelendokComboColor();
	afx_msg void OnCheckItalic();
	afx_msg void OnCheckUnder();
	afx_msg void OnCheckBold();
	afx_msg void OnDraw();
	afx_msg void OnRadioSpace();
	afx_msg void OnRadioSpace15();
	afx_msg void OnRadioSpace2();
	afx_msg void OnSelendokComboFont();
	afx_msg void OnSelChange();
	afx_msg void OnButtonSymbol();
	afx_msg void OnButtonSpaceP();
	afx_msg void OnButtonSpaceM();
	afx_msg void OnSelendokComboSpaceStyle();
	afx_msg void OnButtonX();
	afx_msg void OnButtonY();
	afx_msg void OnButtonCourse();
	afx_msg void OnButton1();
	afx_msg void OnKillfocusEditWidth();
	afx_msg void OnEditchangeComboHeight();
	afx_msg void OnButtonLook();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnGetMinMaxInfo(MINMAXINFO* pMMI);
	afx_msg void OnDestroy();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg UINT OnNcHitTest(CPoint point);
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
		

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MSTRINGDLG_H__2C27D519_B641_4F4E_969C_90A5DD576F4A__INCLUDED_)
